; ==== banking ====
.memorymap
defaultslot 0
slotsize $8000
slot 0 $0000
.endme

.rombankmap
bankstotal 1
banksize $8000
banks 1
.endro

.computesmschecksum

.sdsctag 1.0,"Example","Example","Grz-"

; ==== Boot section ====
.bank 0 slot 0
.org $0001

    di
    im 1
    jp main

; ==== pause ====
.org $0066
	retn

; ==== main ====
main:
    ld sp, $dff0
	
    ld hl,VdpData
    ld b,VdpDataEnd-VdpData
    ld c,$bf
    otir

	; ==== clear vram ====
    ld hl,$4000 
    call VRAMToHL 
	call ClrVRAM
	
    ; ==== display ====
    ld a,%11000000
	
    out ($bf),a
    ld a,$81
    out ($bf),a	

	loop:
		; setup raster bar beginning position
		ld b, 190/2-64/2
        call WaitVBL ; display it
		jp loop
 
VRAMToHL:
	push af
		ld a,l
		out ($bf),a
		ld a,h
		out ($bf),a
	pop af
	ret

WriteToHL:
	push af
	push bc 
	push hl
	push de
		-:
			ld a,(hl)
			ld (de),a
			inc hl
			inc de
			dec b
			jp nz,-
	pop de
	pop hl 
	pop bc 
	pop af
	ret	

ClrVRAM:
	push af
	push bc
		ld bc,$4000
		ld a,$00
		bclrvram:
			out ($be),a
		    dec c
		    jp nz,bclrvram
		    dec b 
		    jp nz,bclrvram 
	pop bc
	pop af
	ret

; raster bar effect
WaitVBL:	
	-:
		; fill the rest with black color
		push hl
			ld hl,$C000
			call VRAMToHL
			ld a,$00
			out ($be),a
		pop hl
		
		; wait the beginning line
		WaitLine: 
			in a, ($7E) 
			cp b
		jr nz, WaitLine
		
		; load first color
		push bc
		ld hl,Raster
		ld b,Raster-RasterEnd
		
		rasterLoop:
	
		; wait the next line to avoid flickers
		WaitNextLine:
			in a, ($7E)
			add a,b
			xor a
		jr nz, WaitNextLine
		
		ld a,(hl)
		
		; change the first color in the palette
		push hl
			ld hl,$C000
			call VRAMToHL
			out ($be),a
		pop hl
						
		inc hl ; go to the next color value
		
		; get actual scanline
		in a, ($7E)
		ld d,a
		
		djnz rasterLoop ; loop over all stored colors
		pop bc
		
		; vbl
		in a,($BF)
		and $80
	
		jp z,-
		ret

; ==== data ====
; VDP data
VdpData:
.db $04,$80,$84,$81,$ff,$82,$ff,$85,$ff,$86,$ff,$87,$00,$88,$00,$89,$ff,$8a
VdpDataEnd:

; raster colors data
Raster:
.db $01, $02, $03, $04, $05, $06, $07, $08, $09, $0A, $0B, $0C, $0D, $0E, $0F, $10, $11, $12, $13, $14, $15, $16, $17, $18, $19, $1A, $1B, $1C, $1D, $1E, $1F, $20, $21, $22, $23, $24, $25, $26, $27, $28, $29, $2A, $2B, $2C, $2D, $2E, $2F, $30, $31, $32, $33, $34, $35, $36, $37, $38, $39, $3A, $3B, $3C, $3D, $3E, $3F
RasterEnd: